/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;



import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomValue;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;




/**
 * A Sequence of Repeating Items that describe the energy window groups used.
 */
public class EnergyWindowInformationSequenceItem extends Item  
{
	

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader
	 */
	EnergyWindowInformationSequenceItem()
	{
		super();
	}

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader.
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax  
	 */
	EnergyWindowInformationSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	EnergyWindowInformationSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/**
	 * Validates all the attributes in AcquisitionContextSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule() throws InvalidItemException
	{
		if(contains(0x0054, 0x0013))
			getEnergyWindowRangeSequence().validateForModule();
		return true;
	}

	/**
	 * Sets a user defined name which describes this Energy Window.
	 * @param strEnergyWindowName String value of Energy Window Name
	 */
	public void setEnergyWindowName(String strEnergyWindowName)
	{
		/*Accept the Energy Window Name in String format of type SH.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * 
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0054, 0x0012, strEnergyWindowName,objIDictionaryReader);
		else
			objIDataElement = new ExplicitDE(0x0054, 0x0012,DicomConstants.DCM_DT_SH, strEnergyWindowName);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves user defined name which describes this Energy Window.
	 * @return String - value of Energy Window Name.
	 */
	public String getEnergyWindowName()
	{
		Object objValue = getValue(0x0054, 0x0012);
		if(objValue != null)
			return objValue.toString();
		return null;
	}

	/**
	 * Retrieves pre-initialized object of Energy Window Range Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence.
	 * @return EnergyWindowRangeSequence - instance of EnergyWindowRangeSequence. 
	 */
	public EnergyWindowRangeSequence getEnergyWindowRangeSequence()
	{
		EnergyWindowRangeSequence objEnergyWindowRangeSequence = null;
		IDataElement objIDataElement =  getDataForTag(0x0054,0x0013);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objEnergyWindowRangeSequence = (EnergyWindowRangeSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objEnergyWindowRangeSequence = (EnergyWindowRangeSequence)objDicomV3Factory.createSequence(0x0054,0x0013, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x0054,0x0013, objEnergyWindowRangeSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x0054,0x0013, DicomConstants.DCM_DT_SQ, objEnergyWindowRangeSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objEnergyWindowRangeSequence;
	}
}
